import { HttpClient } from '@angular/common/http';
import { NgxSpinnerService } from 'ngx-spinner';
import { ActivatedRoute, Params } from '@angular/router';
import { Location } from '@angular/common';
import { AuthServiceService } from './../../../shared/auth-service.service';
import { ToastrService } from 'ngx-toastr';
import { DashboardService } from './../../../shared/dashboard.service';
import { Component, OnInit, ViewChild } from '@angular/core';
import { NgForm } from '@angular/forms';

@Component({
  selector: 'app-location-add',
  templateUrl: './location-add.component.html',
  styleUrls: ['./location-add.component.css']
})
export class LocationAddComponent implements OnInit {

  
  constructor(private dashBoardSer: DashboardService,
    private toastr: ToastrService,
    private authSer: AuthServiceService,
    private route: ActivatedRoute,
    private spinner: NgxSpinnerService,
    private location: Location,
    private http: HttpClient
  ) { }

  @ViewChild('f') definitionForm : NgForm;

  
  typePage: string = '';
  locations =[];
  valueType: string = '';
  checkSaveclick:boolean = false;
  check : boolean = false;
  isEdit: boolean = false;
  types = [
    {
      name : 'تصنيف رئيسي',
      value : 'main'
    },
    {
      name : 'تصنيف فرعي',
      value : 'sub'
    }
  ];

  
  editPageId: number;



  formData = {
    parent_id: null,
    type : '',
    status : '1',
    name: '',
    // parent_name: ''
  }
  ngOnInit() {
    this.http.get(this.authSer.pathApi + '/parent_locations_list').subscribe(
      (response) => {
        
        this.locations = response['locations']
        console.log('XXXX',response);
      },
      (error) => {
        console.log(error);
      }
    );
    this.route.params.subscribe(
      (params: Params) => {
        this.editPageId = +params['locationEditPageId'];
      }
    );


    if (this.editPageId) {
      this.spinner.show();
      this.isEdit = true;
      this.typePage = 'تعديل';
      this.dashBoardSer.getItemData(this.editPageId, 'definitionOfLocation' ).subscribe(
        (response) => {
          console.log('ssss', response);
          this.formData.parent_id = response['location'].parent_id;
          this.formData.name  = response['location'].name;
          this.formData.status = response['location'].status;
          if (this.formData.parent_id != null) {
            this.formData.type = 'sub';
            this.check = true;
          } else {
            this.formData.type = 'main';
          }
          // this.formData.parent_name = response['category'].parent_name;
          // console.log(this.formData.parent_name );
          this.spinner.hide();
        },
        (error) => {
          console.log(error);
        }
      );
    }else {
      this.typePage = 'اضافة';
    }




  }

  onChangeType(event){
    this.valueType = event.target.value;
    console.log(this.valueType);
  }
  onSubmitted() {
    console.log('HERE',this.definitionForm.value);
    if(this.editPageId) {
      this.dashBoardSer.editItem(this.editPageId, this.definitionForm.value, 'definitionOfLocation').subscribe(
        (responce) => {
          console.log(responce);
          this.toastr.success('تم التعديل بنجاح');
          this.location.back();
        },
        (error) => {
          console.log(error);
          this.toastr.error('خطأ في الخادم ، رجاء المحارله لاحقا');
        }
      )
    } else {
    this.dashBoardSer.addItem( this.definitionForm.value , 'definitionOfLocation').subscribe(
      (responce) => {
        console.log('ADD',responce);
        this.toastr.success('تم الإضافه بنجاح');
        this.checkSaveclick = false;
        this.location.back();
      },
      (error) => {
        console.log(error);
        this.checkSaveclick = false;
        this.toastr.error('خطأ في الخادم ، حاول لاحقا');
      }
    );
    }
  }
}
